<?php
error_reporting(E_ALL);
//Descripton:
//Converts a collection of txt files to and organized html collection
//Author : Sam Stevens <sam@xnet.tk>
//Requirements : Available temp directory, txt2html version 2.45 min (external)

###################  Configuration  ###################

// The name of the collection
	$name = "Compilers";
// The list of available pages (in order).
	$pages = array ('file1.txt','file2.txt','file3.txt');
// The default page to show
	$defaultPage = $pages[0];
//The temp directory to use.
	$tempDir = "/tmp";
//Override the scriptName (If you change this scripts name, ie index.php)
	//$scriptName = "txt2dir.php";

################  End of Configuration  ################

//Add boolean false to beginning and end of page array
$pages = array_merge(array(false),$pages,array(false));

//Determin script action
$action=(isset($_REQUEST['action'])) ? $_REQUEST['action'] : 'page';

//Determin and validate page request
$page=(isset($_GET['page']) && in_array($_GET['page'],$pages)) ? $_GET['page'] : $defaultPage;

//Determin page number
$pageIndex = array_search($page,$pages);

//Determin the scripts name
$scriptName = (isset($scriptName)) ? $scriptName : $_SERVER['PHP_SELF'];

//Hand off to appropiate handler function
switch($action)
{
	case 'page':
		showPage();
		break;
	case 'index':
	default:
		showIndex();
		break;
}

function showIndex()
{
	global $pages, $name, $scriptName;

	//Write out header'n'stuff
	echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"
\"http://www.w3.org/TR/html4/strict.dtd\">
<HTML>
<HEAD>
<TITLE>$name - Index</TITLE>
</HEAD>
<BODY>";
	echo "<h2>Navigation</h2>\n";
	//Write out each page entry as "Page # : link"
	foreach($pages as $key=>$fileName)
	{
		if ($fileName === false)
			continue;
		echo "Page $key : <a href=\"$scriptName?action=page&amp;page=$fileName\">$fileName</a><br>\n";
	}
	//Close html document
	echo "</BODY></HTML>";
}
function showPage()
{
	global $page, $pageIndex, $pages, $name, $tempDir, $scriptName;

	//open and create temp file, needed to insert header into the 
	//html file, as txt2html requires a file rather than a string
	$navFileName = tempnam($tempDir,"php");
	$navFile = fopen($navFileName, "w") or
		die("Error creating temp file");;

	//Start nav, with link to index
	$nav = "| <b>Navigation</b> | <a href=\"$scriptName?action=index\">Index</a> | ";

	//If this isnt the first page show a link to the previous one
	if (isset($pages[$pageIndex-1]) && $pages[$pageIndex-1] !== false)
		$nav .="<a href=\"$scriptName?action=page&amp;page=".$pages[$pageIndex-1]."\">Previous</a> | ";
	else
		$nav .="Previous | ";

	//If this isnt the last page show a link to the next one
	if (isset($pages[$pageIndex+1]) && $pages[$pageIndex+1] !== false)
		$nav .="<a href=\"$scriptName?action=page&amp;page=".$pages[$pageIndex+1]."\">Next</a> | ";
	else
		$nav .="Next | ";

	//Show page number
	$nav.= "Page ".$pageIndex." | ";
	$nav.="<br>\n";

	//Write nav to the temp file
	fwrite($navFile,$nav);
	//Force write
	fflush($navFile);

	//Get the converted text
	$pageContents=`txt2html $page -t "$name - Page $pageIndex" -pp $navFileName`;

	//Close the temp file
	fclose($navFile);
	//Delete the temp file
	unlink($navFileName);

	//Echo the resulting text
	echo $pageContents;
}
?>
